//<?php
/**
 * 不正ログインプロテクター
 * 
 * 不正ログインを試みるアクセスを検出し、防御します
 *
 * @category    plugin
 * @version     1.3
 * @license     http://www.gnu.org/copyleft/gpl.html GNU Public License (GPL)
 * @internal    @events OnBeforeManagerLogin
 * @internal    @modx_category Manager and Admin
 */

$uri = $_SERVER['REQUEST_URI'];
if($_POST) $uri .= join('',$_POST);

if    (strpos($uri,',')!==false)  $type = 'A';
elseif(strpos($uri,'[]')!==false) $type = 'B';
elseif(strpos($uri,'?')!==false
	&& !isset($_GET['hash'])
	&& !isset($_GET['key']))      $type = 'unknown';

switch($type)
{
	case 'A':
	case 'B':
	case 'unknown':
		$ip = $_SERVER['REMOTE_ADDR'];
		$info  = date('Y-m-d H:i:s') . "\n\n";
		$server = $_SERVER;
		if(isset($server['REQUEST_URI']))  unset($server['REQUEST_URI']);
		if(isset($server['argv']))         unset($server['argv']);
		if(isset($server['QUERY_STRING'])) unset($server['QUERY_STRING']);
		$info .= '$_SERVER' . "\n" . print_r($server,true) . "\n\n";
		if($_POST)   $info .= '$_POST' . "\n" . print_r($_POST,true) . "\n\n";
		if($_COOKIE) $info .= '$_COOKIE' . "\n" . print_r($_COOKIE,true) . "\n\n";

		$title = '不正ログインを試みるアクセスを検出。防御しました。';
		$msg = "{$title}\nip : {$ip}\ntype : {$type}\ndetail:\n{$info}\n";
		if(isset($_REQUEST['username'])) $msg .= "\nusername : {$_GET['username']}";
		if(isset($_REQUEST['name'])) $msg .= "\nusername : {$_GET['name']}";
		$log_detail = nl2br($msg);
		if(isset($modx->config['send_errormail'])) $modx->config['send_errormail'] = '0';
		$modx->logEvent(0, 3, $log_detail,'Illegal Login Attack');
		if(method_exists($modx, 'sendmail'))
    	{
    		$p['subject'] = $title;
    		$modx->sendmail($p,$msg);
		}
		else
		{
    		include_once MODX_MANAGER_PATH . 'includes/controls/class.phpmailer.php';
    		$mail = new PHPMailer();
    		$mail->IsMail();
    		$mail->IsHTML(false);
    		$mail->From     = $modx->config['emailsender'];
    		$mail->FromName = $modx->config['site_name'];
    		$mail->Subject  = 'Alert of illegal Login Attack';
    		$mail->Body     = "See event log\n" . $modx->config['site_url'] . "manager/\n\n" . $msg;
    		$mail->AddAddress($modx->config['emailsender']);
    		$mail->send(); //ignore mail errors in this case
		}
		echo "Hello {$ip} You were blocked.";
		exit;
		break;
	default:
		return;
}

